/* /////////////////////////////////////////////////////////////////////////
 * File:    unixem/unixem.h
 *
 * Purpose: Root header for the UNIXem API.
 *
 * Created: 29th August 2005
 * Updated: 12th August 2010
 *
 * Home:    http://synesis.com.au/software/
 *
 * Copyright (c) 2005-2010, Matthew Wilson and Synesis Software
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 * - Neither the name(s) of Matthew Wilson and Synesis Software nor the
 *   names of any contributors may be used to endorse or promote products
 *   derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ////////////////////////////////////////////////////////////////////// */


/** \file unixem/unixem.h Root header for the UNIXem API
 */

#ifndef UNIXEM_INCL_UNIXEM_H_UNIXEM
#define UNIXEM_INCL_UNIXEM_H_UNIXEM

/* /////////////////////////////////////////////////////////////////////////
 * Version
 */

#ifndef UNIXEM_DOCUMENTATION_SKIP_SECTION
# define UNIXEM_VER_UNIXEM_H_UNIXEM_MAJOR       1
# define UNIXEM_VER_UNIXEM_H_UNIXEM_MINOR       6
# define UNIXEM_VER_UNIXEM_H_UNIXEM_REVISION    1
# define UNIXEM_VER_UNIXEM_H_UNIXEM_EDIT        14
#endif /* !UNIXEM_DOCUMENTATION_SKIP_SECTION */

/** \def UNIXEM_VER_MAJOR
 * The major version number of UNIXem
 */

/** \def UNIXEM_VER_MINOR
 * The minor version number of UNIXem
 */

/** \def UNIXEM_VER_REVISION
 * The revision version number of UNIXem
 */

/** \def UNIXEM_VER
 * The current composite version number of UNIXem
 */

#define UNIXEM_VER_MAJOR       1
#define UNIXEM_VER_MINOR       9
#define UNIXEM_VER_REVISION    1

#define UNIXEM_VER             0x010901ff

/* ////////////////////////////////////////////////////////////////////// */

#endif /* UNIXEM_INCL_UNIXEM_H_UNIXEM */

/* ///////////////////////////// end of file //////////////////////////// */
